/* tr_lfind - find node matching a specified key
 * iterative version
 * never returns NULL
 */
#include "tree.h"
TR_NODE **tr_lfind(plt, pn, cmpfn)
	TR_NODE **plt;			/* ptr to link-in of tree or subtree */
	TR_NODE *pn;			/* ptr to structure containing key to match */
	int (*cmpfn)();			/* ptr to comparison function */
	{
	TR_NODE *pt;			/* ptr to current tree */
	int cmp;				/* comparison result: neg, zero, pos */

	FOREVER
		{
		pt = *plt;					/* pt now points to current tree */
		if (pt == NULL)				/* if plt points to a null pointer, */
			return (plt);			/* the data isn't in the tree */
		else if ((cmp = (*cmpfn)(pn, pt)) == 0) /* if key already in tree, */
			return (plt);			/* return its node's link-in */
		else if (cmp < 0)			/* if key compares low, */
			plt = &TR_LEFT(pt);		/* then search in left tree */
		else						/* otherwise, */
			plt = &TR_RIGHT(pt);		/* search in right tree */
		}
	}
